/*
 * mygame.h: ɮxCclassinterface
 * Copyright (C) 2002-2008 Woei-Kae Chen <wkc@csie.ntut.edu.tw>
 *
 * This file is part of game, a free game development framework for windows.
 *
 * game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * game is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *	 2004-03-02 V4.0
 *      1. Add CGameStateInit, CGameStateRun, and CGameStateOver to
 *         demonstrate the use of states.
 *   2005-09-13
 *      Rewrite the codes for CBall and CEraser.
 *   2005-09-20 V4.2Beta1.
 *   2005-09-29 V4.2Beta2.
 *   2006-02-08 V4.2
 *      1. Rename OnInitialUpdate() -> OnInit().
 *      2. Replace AUDIO_CANYON as AUDIO_NTUT.
 *      3. Add help bitmap to CGameStateRun.
 *   2006-09-09 V4.3
 *      1. Rename Move() and Show() as OnMove and OnShow() to emphasize that they are
 *         event driven.
 *   2008-02-15 V4.4
 *      1. Add namespace game_framework.
 *      2. Replace the demonstration of animation as a new bouncing ball.
 *      3. Use ShowInitProgress(percent) to display loading progress. 
*/

/////////////////////////////////////////////////////////////////////////////
// Constants
/////////////////////////////////////////////////////////////////////////////

enum AUDIO_ID {				// wqUحĪs
	AUDIO_DING,				// 0
	AUDIO_LAKE,				// 1
	AUDIO_NTUT				// 2
};

namespace game_framework {
/////////////////////////////////////////////////////////////////////////////
// oclassѥiHLηƹl
// NiHgۤv{F
/////////////////////////////////////////////////////////////////////////////

class CEraser
{
public:
	CEraser();
	int  GetX1();					// lW x y
	int  GetY1();					// lW y y
	int  GetX2();					// lkU x y
	int  GetY2();					// lkU y y
	void Initialize();				// ]wll
	void LoadBitmap();				// Jϧ
	void OnMove();					// l
	void OnShow();					// NlϧζKe
	void SetMovingDown(bool flag);	// ]wO_bU
	void SetMovingLeft(bool flag);	// ]wO_b
	void SetMovingRight(bool flag); // ]wO_bk
	void SetMovingUp(bool flag);	// ]wO_bW
	void SetXY(int nx, int ny);		// ]wlWy
protected:
	CAnimation animation;		// lʵe
	int x, y;					// lWy
	bool isMovingDown;			// O_bU
	bool isMovingLeft;			// O_b
	bool isMovingRight;			// O_bk
	bool isMovingUp;			// O_bW
};

/////////////////////////////////////////////////////////////////////////////
// oclass¶骺y
// NiHgۤv{F
/////////////////////////////////////////////////////////////////////////////

class CBall
{
public:
	CBall();
	bool HitEraser(CEraser *eraser);						// O_Il
	bool IsAlive();											// O_
	void LoadBitmap();										// Jϧ
	void OnMove();											// 
	void OnShow();											// NϧζKe
	void SetXY(int nx, int ny);								// ]wߪy
	void SetIsAlive(bool alive);							// ]wO_
	void SetDelay(int d);									// ]w઺t
protected:
	CMovingBitmap bmp;			// y
	CMovingBitmap bmp_center;	// ߪ			
	int x, y;					// ߪy
	int dx, dy;					// yZߪ첾q
	int index;					// yuסvA0-170-360
	int delay_counter;			// վtתpƾ
	int delay;					// ઺t
	bool is_alive;				// O_
private:
	bool HitRectangle(int tx1, int ty1, int tx2, int ty2);	// O_IѼƽd򪺯x
};

/////////////////////////////////////////////////////////////////////////////
// oclassѷ|@uy
// NiHgۤv{F
/////////////////////////////////////////////////////////////////////////////

class CBouncingBall
{
public:
	CBouncingBall();
	void LoadBitmap();		// Jϧ
	void OnMove();			// 
	void OnShow();			// NϧζKe
private:
	int x, y;				// ϧήy
	int floor;				// aOYy
	bool rising;			// trueWɡBfalseU
	int initial_velocity;	// lt
	int velocity;			// ثet(I/)
	CAnimation animation;	// Qΰʵe@ϧ
};

/////////////////////////////////////////////////////////////////////////////
// oclassCC}Ye
// CMember functionImplementationn
/////////////////////////////////////////////////////////////////////////////

class CGameStateInit : public CGameState {
public:
	CGameStateInit(CGame *g);
	void OnInit();  								// CȤιϧγ]w
	void OnBeginState();							// ]wCһݪܼ
	void OnKeyUp(UINT, UINT, UINT); 				// BzLUpʧ@
	void OnLButtonDown(UINT nFlags, CPoint point);  // Bzƹʧ@
protected:
	void OnShow();									// ܳoӪACe
private:
	CMovingBitmap logo;								// csielogo
};

/////////////////////////////////////////////////////////////////////////////
// oclassCC檫ADnC{bo
// CMember functionImplementationn
/////////////////////////////////////////////////////////////////////////////

class CGameStateRun : public CGameState {
public:
	CGameStateRun(CGame *g);
	~CGameStateRun();
	void OnBeginState();							// ]wCһݪܼ
	void OnInit();  								// CȤιϧγ]w
	void OnKeyDown(UINT, UINT, UINT);
	void OnKeyUp(UINT, UINT, UINT);
	void OnLButtonDown(UINT nFlags, CPoint point);  // Bzƹʧ@
	void OnLButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnMouseMove(UINT nFlags, CPoint point);	// Bzƹʧ@ 
	void OnRButtonDown(UINT nFlags, CPoint point);  // Bzƹʧ@
	void OnRButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
protected:
	void OnMove();									// ʹC
	void OnShow();									// ܳoӪACe
private:
	const int		NUMBALLS;	// y`
	CMovingBitmap	background;	// I
	CMovingBitmap	help;		// 
	CBall			*ball;		// y}C
	CMovingBitmap	corner;		// 
	CEraser			eraser;		// l
	CInteger		hits_left;	// ѤU
	CBouncingBall   bball;		// мuy
};

/////////////////////////////////////////////////////////////////////////////
// oclassCA(Game Over)
// CMember functionImplementationn
/////////////////////////////////////////////////////////////////////////////

class CGameStateOver : public CGameState {
public:
	CGameStateOver(CGame *g);
	void OnBeginState();							// ]wCһݪܼ
	void OnInit();
protected:
	void OnMove();									// ʹC
	void OnShow();									// ܳoӪACe
private:
	int counter;	// ˼Ƥpƾ
};

}